"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTransformLibraryName = void 0;
function getTransformLibraryName(transform, importName) {
    if (typeof transform === "function") {
        return transform(importName);
    }
    return importName ? "".concat(transform, "/").concat(importName) : transform;
}
exports.getTransformLibraryName = getTransformLibraryName;
function default_1(api) {
    var types = api.types;
    return {
        visitor: {
            ImportDeclaration: function (path, state) {
                var _a, _b;
                var libraryName = (_a = Object.keys(state.opts)) === null || _a === void 0 ? void 0 : _a.find(function (key) {
                    return types.isStringLiteral(path.node.source, { value: key });
                });
                if (!libraryName)
                    return;
                var transform = ((_b = state.opts[libraryName]) === null || _b === void 0 ? void 0 : _b.transform) || libraryName;
                var fullImports = [];
                var memberImports = [];
                var isFullTransformed = false;
                path.node.specifiers.forEach(function (spec) {
                    var _a, _b;
                    // import { member } from 'module'; (ImportSpecifier)
                    // import { member as alias } from 'module' (ImportSpecifier)
                    if (types.isImportSpecifier(spec)) {
                        var importName = (_a = spec.imported) === null || _a === void 0 ? void 0 : _a.name;
                        var localName = (_b = spec.local) === null || _b === void 0 ? void 0 : _b.name;
                        var libName = getTransformLibraryName(transform, importName);
                        memberImports.push(types.importDeclaration([types.importDefaultSpecifier(types.identifier(localName))], types.stringLiteral(libName)));
                    }
                    else {
                        // import name from 'module'; (ImportDefaultSpecifier)
                        // import * as name from 'module'; (ImportNamespaceSpecifier)
                        // ImportDefaultSpecifier 和 ImportNamespaceSpecifier 没有 importName
                        var libName = getTransformLibraryName(transform);
                        // 全量导入只转换后面引入的库名称
                        fullImports.push(types.importDeclaration([spec], types.stringLiteral(libName)));
                        // 引入的库名称是否被转换过，相同表示转换过
                        if (!isFullTransformed) {
                            isFullTransformed = types.isStringLiteral(path.node.source, {
                                value: libName,
                            });
                        }
                    }
                });
                // 当有成员导入 或 全量导入未转换库名称
                if (memberImports.length > 0 || !isFullTransformed) {
                    // replace imports
                    path.replaceWithMultiple(__spreadArray(__spreadArray([], fullImports, true), memberImports, true));
                }
            },
        },
    };
}
exports.default = default_1;
